# This module is not meant for public use and will be removed in SciPy v2.0.0.

from typing import Any, Final, Protocol, type_check_only
from typing_extensions import deprecated

__all__ = [
    "bispeu",
    "bispev",
    "curfit",
    "dblint",
    "fpchec",
    "fpcurf0",
    "fpcurf1",
    "fpcurfm1",
    "parcur",
    "parder",
    "pardeu",
    "pardtc",
    "percur",
    "regrid_smth",
    "regrid_smth_spher",
    "spalde",
    "spherfit_lsq",
    "spherfit_smth",
    "splder",
    "splev",
    "splint",
    "sproot",
    "surfit_lsq",
    "surfit_smth",
    "types",
]

###

@type_check_only
class _DeprecatedFortranFunction(Protocol):
    __name__: str

    @deprecated(
        "The `scipy.interpolate.dfitpack` namespace is deprecated and will be removed in SciPy 2.0.0. "
        "Please use the `scipy.interpolate` namespace instead."
    )
    def __call__(self, /, *args: object, **kwds: object) -> Any: ...  # noqa: ANN401

###

bispeu: Final[_DeprecatedFortranFunction] = ...
bispev: Final[_DeprecatedFortranFunction] = ...
fpchec: Final[_DeprecatedFortranFunction] = ...
fpcurf0: Final[_DeprecatedFortranFunction] = ...
fpcurf1: Final[_DeprecatedFortranFunction] = ...
fpcurfm1: Final[_DeprecatedFortranFunction] = ...
dblint: Final[_DeprecatedFortranFunction] = ...
parcur: Final[_DeprecatedFortranFunction] = ...
parder: Final[_DeprecatedFortranFunction] = ...
pardeu: Final[_DeprecatedFortranFunction] = ...
pardtc: Final[_DeprecatedFortranFunction] = ...
percur: Final[_DeprecatedFortranFunction] = ...
regrid_smth: Final[_DeprecatedFortranFunction] = ...
regrid_smth_spher: Final[_DeprecatedFortranFunction] = ...
curfit: Final[_DeprecatedFortranFunction] = ...
spherfit_lsq: Final[_DeprecatedFortranFunction] = ...
spherfit_smth: Final[_DeprecatedFortranFunction] = ...
surfit_lsq: Final[_DeprecatedFortranFunction] = ...
surfit_smth: Final[_DeprecatedFortranFunction] = ...
types: Final[_DeprecatedFortranFunction] = ...

spalde: Final[_DeprecatedFortranFunction] = ...
splder: Final[_DeprecatedFortranFunction] = ...
splev: Final[_DeprecatedFortranFunction] = ...
splint: Final[_DeprecatedFortranFunction] = ...
sproot: Final[_DeprecatedFortranFunction] = ...
