from collections.abc import Mapping
from typing import Final, TypedDict, type_check_only
from typing_extensions import CapsuleType, Never, ReadOnly

@type_check_only
class _CApiDict(TypedDict):
    caxpy: ReadOnly[CapsuleType]
    ccopy: ReadOnly[CapsuleType]
    cdotc: ReadOnly[CapsuleType]
    cdotu: ReadOnly[CapsuleType]
    cgbmv: ReadOnly[CapsuleType]
    cgemm: ReadOnly[CapsuleType]
    cgemv: ReadOnly[CapsuleType]
    cgerc: ReadOnly[CapsuleType]
    cgeru: ReadOnly[CapsuleType]
    chbmv: ReadOnly[CapsuleType]
    chemm: ReadOnly[CapsuleType]
    chemv: ReadOnly[CapsuleType]
    cher: ReadOnly[CapsuleType]
    cher2: ReadOnly[CapsuleType]
    cher2k: ReadOnly[CapsuleType]
    cherk: ReadOnly[CapsuleType]
    chpmv: ReadOnly[CapsuleType]
    chpr: ReadOnly[CapsuleType]
    chpr2: ReadOnly[CapsuleType]
    crotg: ReadOnly[CapsuleType]
    cscal: ReadOnly[CapsuleType]
    csrot: ReadOnly[CapsuleType]
    csscal: ReadOnly[CapsuleType]
    cswap: ReadOnly[CapsuleType]
    csymm: ReadOnly[CapsuleType]
    csyr2k: ReadOnly[CapsuleType]
    csyrk: ReadOnly[CapsuleType]
    ctbmv: ReadOnly[CapsuleType]
    ctbsv: ReadOnly[CapsuleType]
    ctpmv: ReadOnly[CapsuleType]
    ctpsv: ReadOnly[CapsuleType]
    ctrmm: ReadOnly[CapsuleType]
    ctrmv: ReadOnly[CapsuleType]
    ctrsm: ReadOnly[CapsuleType]
    ctrsv: ReadOnly[CapsuleType]
    dasum: ReadOnly[CapsuleType]
    daxpy: ReadOnly[CapsuleType]
    dcabs1: ReadOnly[CapsuleType]
    dcopy: ReadOnly[CapsuleType]
    ddot: ReadOnly[CapsuleType]
    dgbmv: ReadOnly[CapsuleType]
    dgemm: ReadOnly[CapsuleType]
    dgemv: ReadOnly[CapsuleType]
    dger: ReadOnly[CapsuleType]
    dnrm2: ReadOnly[CapsuleType]
    drot: ReadOnly[CapsuleType]
    drotg: ReadOnly[CapsuleType]
    drotm: ReadOnly[CapsuleType]
    drotmg: ReadOnly[CapsuleType]
    dsbmv: ReadOnly[CapsuleType]
    dscal: ReadOnly[CapsuleType]
    dsdot: ReadOnly[CapsuleType]
    dspmv: ReadOnly[CapsuleType]
    dspr: ReadOnly[CapsuleType]
    dspr2: ReadOnly[CapsuleType]
    dswap: ReadOnly[CapsuleType]
    dsymm: ReadOnly[CapsuleType]
    dsymv: ReadOnly[CapsuleType]
    dsyr: ReadOnly[CapsuleType]
    dsyr2: ReadOnly[CapsuleType]
    dsyr2k: ReadOnly[CapsuleType]
    dsyrk: ReadOnly[CapsuleType]
    dtbmv: ReadOnly[CapsuleType]
    dtbsv: ReadOnly[CapsuleType]
    dtpmv: ReadOnly[CapsuleType]
    dtpsv: ReadOnly[CapsuleType]
    dtrmm: ReadOnly[CapsuleType]
    dtrmv: ReadOnly[CapsuleType]
    dtrsm: ReadOnly[CapsuleType]
    dtrsv: ReadOnly[CapsuleType]
    dzasum: ReadOnly[CapsuleType]
    dznrm2: ReadOnly[CapsuleType]
    icamax: ReadOnly[CapsuleType]
    idamax: ReadOnly[CapsuleType]
    isamax: ReadOnly[CapsuleType]
    izamax: ReadOnly[CapsuleType]
    lsame: ReadOnly[CapsuleType]
    sasum: ReadOnly[CapsuleType]
    saxpy: ReadOnly[CapsuleType]
    scasum: ReadOnly[CapsuleType]
    scnrm2: ReadOnly[CapsuleType]
    scopy: ReadOnly[CapsuleType]
    sdot: ReadOnly[CapsuleType]
    sdsdot: ReadOnly[CapsuleType]
    sgbmv: ReadOnly[CapsuleType]
    sgemm: ReadOnly[CapsuleType]
    sgemv: ReadOnly[CapsuleType]
    sger: ReadOnly[CapsuleType]
    snrm2: ReadOnly[CapsuleType]
    srot: ReadOnly[CapsuleType]
    srotg: ReadOnly[CapsuleType]
    srotm: ReadOnly[CapsuleType]
    srotmg: ReadOnly[CapsuleType]
    ssbmv: ReadOnly[CapsuleType]
    sscal: ReadOnly[CapsuleType]
    sspmv: ReadOnly[CapsuleType]
    sspr: ReadOnly[CapsuleType]
    sspr2: ReadOnly[CapsuleType]
    sswap: ReadOnly[CapsuleType]
    ssymm: ReadOnly[CapsuleType]
    ssymv: ReadOnly[CapsuleType]
    ssyr: ReadOnly[CapsuleType]
    ssyr2: ReadOnly[CapsuleType]
    ssyr2k: ReadOnly[CapsuleType]
    ssyrk: ReadOnly[CapsuleType]
    stbmv: ReadOnly[CapsuleType]
    stbsv: ReadOnly[CapsuleType]
    stpmv: ReadOnly[CapsuleType]
    stpsv: ReadOnly[CapsuleType]
    strmm: ReadOnly[CapsuleType]
    strmv: ReadOnly[CapsuleType]
    strsm: ReadOnly[CapsuleType]
    strsv: ReadOnly[CapsuleType]
    zaxpy: ReadOnly[CapsuleType]
    zcopy: ReadOnly[CapsuleType]
    zdotc: ReadOnly[CapsuleType]
    zdotu: ReadOnly[CapsuleType]
    zdrot: ReadOnly[CapsuleType]
    zdscal: ReadOnly[CapsuleType]
    zgbmv: ReadOnly[CapsuleType]
    zgemm: ReadOnly[CapsuleType]
    zgemv: ReadOnly[CapsuleType]
    zgerc: ReadOnly[CapsuleType]
    zgeru: ReadOnly[CapsuleType]
    zhbmv: ReadOnly[CapsuleType]
    zhemm: ReadOnly[CapsuleType]
    zhemv: ReadOnly[CapsuleType]
    zher: ReadOnly[CapsuleType]
    zher2: ReadOnly[CapsuleType]
    zher2k: ReadOnly[CapsuleType]
    zherk: ReadOnly[CapsuleType]
    zhpmv: ReadOnly[CapsuleType]
    zhpr: ReadOnly[CapsuleType]
    zhpr2: ReadOnly[CapsuleType]
    zrotg: ReadOnly[CapsuleType]
    zscal: ReadOnly[CapsuleType]
    zswap: ReadOnly[CapsuleType]
    zsymm: ReadOnly[CapsuleType]
    zsyr2k: ReadOnly[CapsuleType]
    zsyrk: ReadOnly[CapsuleType]
    ztbmv: ReadOnly[CapsuleType]
    ztbsv: ReadOnly[CapsuleType]
    ztpmv: ReadOnly[CapsuleType]
    ztpsv: ReadOnly[CapsuleType]
    ztrmm: ReadOnly[CapsuleType]
    ztrmv: ReadOnly[CapsuleType]
    ztrsm: ReadOnly[CapsuleType]
    ztrsv: ReadOnly[CapsuleType]

__pyx_capi__: Final[_CApiDict]
__test__: Final[Mapping[Never, Never]]
